            VAR    V1,ncyc
            VAR    V2,del
            VAR    V3,latenz
            VAR    V4,cycles
            VAR    V5,sdur
            VAR    V6,doneflg=0

            SET      0.200 1 0     ;sequencer tick 0.2ms.
            DIGOUT [.......0]      ;dig. out 0 low initially
A1:         DAC    0,0             ;reset all DACs
            DAC    1,0
            DAC    2,0
            DAC    3,0
            DAC    4,0
            DAC    5,0
            DAC    6,0
            DAC    7,0
            HALT   

;this subroutine does the work of timing the sweeps   
TIMR:       DELAY  del             ;wait for Tinterval - latency
TIMW:       WAVEBR TIMW,W          ;wait longer for arming if necessary
            MARK   1               ;trigger on digital marker channel
            DELAY  latenz          ;latency of playwave stimulus
            DIGOUT [.......1]      ;dig.out 0 high marks stimulus onset
            WAVEST T               ;trigger playwave
            DELAY  sdur            ;give time for playwave to finish
            DIGOUT [.......0]      ;dig. out 0 low marks end of stimulus
WE:         WAVEBR WE,S            ;extra time for playwaveto stop if necesary
            RETURN 
            HALT   

;stop sequence at end of current stimulus
        '0  WAVEST C
            DIGOUT [.......0]      ;dig. out 0 low
            JUMP   A1              ;reset dacs to 0 and halt
            HALT   

;repeated presentation of one of 10 stored waveforms (codes: Z,X,C,V,B,N,M,J,K and L)
        'Z  MOV    cycles,ncyc     ;number of cycles to do
Z1:         WAVEGO z,T             ;prepare to play waveform
            CALL   TIMR
            DBNZ   cycles,z1       ;loop
            MOVI   doneflg,1       ;flag all done
            HALT   
;waveform X  
        'X  MOV    cycles,ncyc     ;number of cycles to do
X1:         WAVEGO x,T             ;prepare to play waveform
            CALL   TIMR
            DBNZ   cycles,X1       ;loop
            MOVI   doneflg,1       ;flag all done
            HALT   
;waveform C  
        'C  MOV    cycles,ncyc     ;number of cycles to do
C1:         WAVEGO c,T             ;prepare to play waveform
            CALL   TIMR
            DBNZ   cycles,C1       ;loop
            MOVI   doneflg,1       ;flag all done
            HALT   
;waveform V  
        'V  MOV    cycles,ncyc     ;number of cycles to do
VV1:        WAVEGO v,T             ;prepare to play waveform
            CALL   TIMR
            DBNZ   cycles,VV1      ;loop
            MOVI   doneflg,1       ;flag all done
            HALT   
;waveform B  
        'B  MOV    cycles,ncyc     ;number of cycles to do
B1:         WAVEGO b,T             ;prepare to play waveform
            CALL   TIMR
            DBNZ   cycles,B1       ;loop
            MOVI   doneflg,1       ;flag all done
            HALT   
;waveform N  
        'N  MOV    cycles,ncyc     ;number of cycles to do
N1:         WAVEGO n,T             ;prepare to play waveform
            CALL   TIMR
            DBNZ   cycles,N1       ;loop
            MOVI   doneflg,1       ;flag all done
            HALT   
;waveform M  
        'M  MOV    cycles,ncyc     ;number of cycles to do
M1:         WAVEGO m,T             ;prepare to play waveform
            CALL   TIMR
            DBNZ   cycles,M1       ;loop
            HALT   
;waveform J  
        'J  MOV    cycles,ncyc     ;number of cycles to do
J1:         WAVEGO j,T             ;prepare to play waveform
            CALL   TIMR
            DBNZ   cycles,J1       ;loop
            MOVI   doneflg,1       ;flag all done
            HALT   
;waveform K  
        'K  MOV    cycles,ncyc     ;number of cycles to do
K1:         WAVEGO k,T             ;prepare to play waveform
            CALL   TIMR
            DBNZ   cycles,K1       ;loop
            MOVI   doneflg,1       ;flag all done
            HALT   
;waveform L  
        'L  MOV    cycles,ncyc     ;number of cycles to do
L1:         WAVEGO l,T             ;prepare to play waveform
            CALL   TIMR
            DBNZ   cycles,L1       ;loop
            MOVI   doneflg,1       ;flag all done
            HALT   


